// Link VS
// $Author: Jeffrey J Weimer$
// SVN History: $Revision: 1066 $ on $Date: 2009-06-29 10:29:30 -0500 (Mon, 29 Jun 2009) $

#define English

#pragma rtGlobals=1
#pragma IgorVersion=6.10
#pragma version=1.2

#pragma IndependentModule=LinkVS

#include "LinkDisplay", version>=2.1

Static StrConstant thePackage="LinkVS"
Static StrConstant thePackageFolder="root:Packages:LinkVS"
Static StrConstant theProcedureFile = "LinkVS.ipf"
Static Constant hasHelp = 1
Static Constant thePackageVersion = 1.2

#ifdef English
Static StrConstant KillMeRequest="Do you really want to remove LinkVS?"
#endif
#ifdef Deutsch
Static StrConstant KillMeRequest="Soll LinkVS wirklich entfernt werden?"
#endif

// Package Constants

// Menu

Menu "Misc"
	Submenu "Panels"
		"LinkVS", /Q, MakeLinkVSPanel()
	end
end

#define NOTEST
Static StrConstant MTNest="--"

#ifdef English
Static StrConstant NoFolders="You have no data folders!"
#endif
#ifdef Deutsch
Static StrConstant NoFolders="Es gibt keinen Data Folders!"
#endif

// Package Functions

// Make the Panel

Function MakeLinkVSPanel()

	string theTopFldr = StringFromList(0,ListofRootDataFolders())
	string theFirstWave = StringFromList(0,ListofWavesinFolder(theTopFldr))
	string GIMN = GetIndependentModuleName()
	string fldrList = GIMN + "#ListofRootDataFolders()"
	string wList = GIMN + "#ListofWavesinFolder(\""+ theTopFldr + "\")"
	
	if (WinType("LinkVS")==7)
		DoWindow/F LinkVS
		return 0
	endif

	NewPanel/W=(10,20,155,170)/K=1/N=LinkVS as "LinkVS"
#ifdef NOTEST
	ModifyPanel/W=LinkVS noEdit=1, fixedSize=1
#endif
	Execute/Z/Q "ProcGlobal#ScreenSizer#ShiftFrontWindow(-10,10)"
	PopupMenu FolderList,pos={2,3},size={84,20},proc=ChangeFolder,title="root:"
	PopupMenu FolderList,font="Arial",fSize=12, mode=1,popvalue=theTopFldr,value= #fldrList

	PopupMenu XWave,pos={2,25},size={120,20},title="x"
	PopupMenu XWave,font="Arial",fSize=12,mode=1,popvalue=theFirstWave,value=#wList

	Button DoIt,pos={2,47},size={20,20},proc=DoIt,title="->",font="Arial",fSize=12

	PopupMenu Task,pos={28,47},size={86,20},font="Arial",fSize=12,proc=ChangeTask
	PopupMenu Task,mode=2,popvalue="AppendVS",value= #"\"DisplayVS;AppendVS;AppendVS*;\""

	SetVariable Title,pos={2,70},size={135,17},title="Title",font="Arial",fSize=12, value= _STR:""

	SetVariable DVSFlags,pos={2,90},size={130,17},title="DspFlags",font="Arial",fSize=12, value= _STR:""

	SetVariable AVSFlags,pos={2,110},size={130,17},title="AVSFlags",font="Arial",fSize=12, value= _STR:""

	CheckBox SetPrefs, pos={50,132},title="*",value=0
	
	Button Help,pos={80,128},size={20,20},proc=GetHelp,title="?",font="Arial", fSize=12

	Button RemoveMe,pos={105,128},size={20,20},title="X",font="Arial", fSize=12, proc=RemoveLinkVS

	string theV
	sprintf theV, "v %g", thePackageVersion
	SetDrawEnv fname= "Arial",fsize= 8
	DrawText 4,145, theV

	return 0
End

// List of Root Data Folders
// removes Packages folder from list
// returns "--" as empty list

Function/S ListofRootDataFolders()

	string LoFldrs="", theOne
	variable ic = 0
	do
		theOne = GetIndexedObjName("root:",4,ic)
		if (strlen(theOne)==0)
			break
		endif
		LoFldrs +=  theOne + ";"
		ic += 1
	while(1)
	
	LoFldrs = RemoveFromList("Packages",LoFldrs)
	
	if (strlen(LoFldrs)==0)
		LoFldrs = MTNest
	endif

	return LoFldrs
end

// List of Waves In Folder

Function/S ListofWavesInFolder(theFldr)
	string theFldr

	string LoWaves="", theOne
	variable ic = 0
	
	sprintf theFldr "root:%s", theFldr
	do
		theOne = GetIndexedObjName(theFldr,1,ic)
		if (strlen(theOne)==0)
			break
		endif
		LoWaves +=  theOne + ";"
		ic += 1
	while(1)
	
	if (strlen(LoWaves)==0)
		LoWaves = MTNest
	endif

	return LoWaves
end

// PopMenu Action to Change Folder

Function ChangeFolder(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			string theCurrFldr = StringFromList(pa.popNum-1,ListofRootDataFolders())
			string theFirstWave = StringFromList(0,ListofWavesinFolder(theCurrFldr))
			string wList = GetIndependentModuleName() + "#ListofWavesinFolder(\""+ theCurrFldr + "\")"
			PopupMenu XWave mode=1, popValue=theFirstWave, value=#wList
			break
	endswitch

	return 0
End

// PopMenu Action to Change Task

Function ChangeTask(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			switch(pa.popNum)
				// DisplayVS
				case 1:
					SetVariable DVSFlags,title="DVSFlags", value= _STR:""
					SetVariable AVSFlags,disable=1
					break
				// AppendVS or AppendVS*
				case 2:
				case 3:
					SetVariable DVSFlags,title="DspFlags", value= _STR:""
					SetVariable AVSFlags,disable=0
					break
			endswitch
			break
	endswitch

	return 0
End

// Button Action to Do It

Function DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2:
			string theTask, theFldr, theWave, title, DVSflags, AVSflags, theCmd, GIMN
			variable prefs
			ControlInfo FolderList
			if (cmpstr(S_value,MTNest)==0)
				DoAlert 0, NoFolders
				break
			endif
			sprintf theFldr "root:%s" S_value
			ControlInfo XWave
			if (cmpstr(S_value,MTNest)==0)
				break
			endif
			sprintf theWave, "%s:%s", theFldr, S_value
			ControlInfo Task
			theTask = S_Value
			ControlInfo Title
			title = S_value
			ControlInfo DVSFlags
			DVSflags = S_Value
			ControlInfo AVSFlags
			AVSflags = S_Value
			GIMN = GetIndependentModuleName()
			ControlInfo SetPrefs
			prefs = V_value
			strswitch(theTask)
				case "DisplayVS":
					if (strlen(title)==0)
						if (strlen(DVSflags)==0)
							sprintf theCmd "%s#LinkDisplay#%s(%s)", GIMN, theTask, theWave
						else
							sprintf theCmd "%s#LinkDisplay#%s(%s,flags=\"%s\")", GIMN, theTask, theWave, DVSflags
						endif
					else
						if (strlen(DVSflags)==0)
							sprintf theCmd "%s#LinkDisplay#%s(%s,title=\"%s\")", GIMN, theTask, theWave, title
						else
							sprintf theCmd "%s#LinkDisplay#%s(%s,flags=\"%s\",title=\"%s\")", GIMN, theTask, theWave, DVSflags, title
						endif
					endif
					break
				case "AppendVS":
					if (strlen(WinName(0,1))==0)
						if (strlen(title)==0)
							sprintf theCmd "Display%s" DVSflags
						else
							sprintf theCmd "Display%s as \"%s\"" DVSflags, title
						endif
						Execute/Q theCmd
					endif
					if (strlen(AVSflags)==0)
						sprintf theCmd "%s#LinkDisplay#%s(%s)", GIMN, theTask, theWave
					else
						sprintf theCmd "%s#LinkDisplay#%s(%s,flags=\"%s\")", GIMN, theTask, theWave, AVSflags
					endif
					break
				case "AppendVS*":
					if (strlen(title)==0)
						sprintf theCmd "Display%s" DVSflags
					else
						sprintf theCmd "Display%s as \"%s\"" DVSflags, title
					endif
					Execute/Q theCmd
					theTask = RemoveEnding(theTask)
					if (strlen(AVSflags)==0)
						sprintf theCmd "%s#LinkDisplay#%s(%s)", GIMN, theTask, theWave
					else
						sprintf theCmd "%s#LinkDisplay#%s(%s,flags=\"%s\")", GIMN, theTask, theWave, AVSflags
					endif
					break
			endswitch
			Preferences prefs
			Execute/Q theCmd
			break
	endswitch
	
	Preferences 0
	return 0
End

// Button Action to Remove LinkVS

Function RemoveLinkVS(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2:
			KillWindow LinkVS
			RemoveMe()
			break
	endswitch
	return 0
end

// Button Action to Get Help

Function GetHelp(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2:
			Help()
			break
	endswitch

	return 0
End

// Help Static Function
 
Function Help([topic])
	string topic
 
	string HelpStr = ""
 
	if (!hasHelp)
		sprintf HelpStr, "NO HELP FOR PACKAGE %s!", thePackage
		DoAlert 0, HelpStr
		return 0
	endif
 
	if (strlen(thePackage)!=0)
		if (ParamIsDefault(topic))
			DisplayHelpTopic/K=1 thePackage
		else
			sprintf HelpStr, "%s[%s]" thePackage, topic
			DisplayHelpTopic/K=1 HelpStr
		endif
	else
		DoAlert 0, "NO PACKAGE NAME FOR HELP!"
		return -1
	endif
	return 0
end

// Remove Me

Function RemoveMe([quiet])
	variable quiet
	
	if (ParamIsDefault(quiet) || (quiet == 0))
		DoAlert 1, KillMeRequest	
		if (V_flag == 2)
			return 0
		endif
	endif
	
	if (strlen(thePackageFolder)!=0)
		KillDataFolder/Z $thePackageFolder
	endif
	
	string theCmd
	if (strlen(thePackage)!=0)
		sprintf theCmd "DELETEINCLUDE \"%s\"" thePackage
		Execute/P/Z/Q theCmd
	endif
	if (strlen(theProcedureFile)!=0)
		sprintf theCmd "CloseProc/NAME=\"%s\"" theProcedureFile	
		Execute/P/Q theCmd
	endif
	
	return 0
end